Index: /LMDZ.3.3/branches/rel-LF/libf/phylmd/interface_surf.F90
===================================================================
--- /LMDZ.3.3/branches/rel-LF/libf/phylmd/interface_surf.F90	(revision 97)
+++ /LMDZ.3.3/branches/rel-LF/libf/phylmd/interface_surf.F90	(revision 98)
@@ -45,13 +45,14 @@
 !
   SUBROUTINE interfsurf_hq(itime, dtime, jour, &
-      & klon, nisurf, knon, knindex, rlon, rlat, &
+      & klon, iim, jjm, nisurf, knon, knindex, pctsrf, rlon, rlat, &
       & debut, lafin, ok_veget, &
-      & zlev, zlflu, u1_lay, v1_lay, temp_air, spechum, hum_air, ccanopy, & 
+      & zlev,  u1_lay, v1_lay, temp_air, spechum, hum_air, ccanopy, & 
       & tq_cdrag, petAcoef, peqAcoef, petBcoef, peqBcoef, &
       & precip_rain, precip_snow, lwdown, swnet, swdown, &
-      & tsurf, p1lay, cal, beta, coef1lay, ps, radsol, dif_grnd, &
+      & albedo, snow, qsol, &
+      & tsurf, p1lay, coef1lay, ps, radsol, &
       & ocean, &
       & evap, fluxsens, fluxlat, dflux_l, dflux_s, &              
-      & tsol_rad, tsurf_new, alb_new, emis_new, z0_new, pctsrf_new)
+      & tsol_rad, tsurf_new, alb_new, emis_new, z0_new, pctsrf_new, zmasq)
 
 
@@ -67,4 +68,5 @@
 !   itime        numero du pas de temps
 !   klon         nombre total de points de grille
+!   iim, jjm     nbres de pts de grille
 !   dtime        pas de temps de la physique (en s)
 !   jour         jour dans l'annee en cours
@@ -72,4 +74,5 @@
 !   knon         nombre de points de la surface a traiter
 !   knindex      index des points de la surface a traiter
+!   pctsrf       tableau des pourcentages de surface de chaque maille
 !   rlon         longitudes
 !   rlat         latitudes
@@ -79,5 +82,312 @@
 !                     (si false calcul simplifie des fluxs sur les continents)
 !   zlev         hauteur de la premiere couche
-!   zlflu        epaisseur de la premier couche
+!   u1_lay       vitesse u 1ere couche
+!   v1_lay       vitesse v 1ere couche
+!   temp_air     temperature de l'air 1ere couche
+!   spechum      humidite specifique 1ere couche
+!   hum_air      humidite de l'air
+!   ccanopy      concentration CO2 canopee
+!   tq_cdrag     cdrag
+!   petAcoef     coeff. A de la resolution de la CL pour t
+!   peqAcoef     coeff. A de la resolution de la CL pour q
+!   petBcoef     coeff. B de la resolution de la CL pour t
+!   peqBcoef     coeff. B de la resolution de la CL pour q
+!   precip_rain  precipitation liquide
+!   precip_snow  precipitation solide
+!   lwdown       flux IR entrant a la surface
+!   swnet        flux solaire net
+!   swdown       flux solaire entrant a la surface
+!   albedo       albedo de la surface
+!   tsurf        temperature de surface
+!   p1lay        pression 1er niveau (milieu de couche)
+!   coef1lay     coefficient d'echange
+!   ps           pression au sol
+!   radsol       rayonnement net aus sol (LW + SW)
+!   ocean        type d'ocean utilise (force, slab, couple)
+!
+! output:
+!   evap         evaporation totale
+!   fluxsens     flux de chaleur sensible
+!   fluxlat      flux de chaleur latente
+!   tsol_rad     
+!   tsurf_new    temperature au sol
+!   alb_new      albedo
+!   emis_new     emissivite
+!   z0_new       surface roughness
+!   pctsrf_new   nouvelle repartition des surfaces
+!   zmasq        masque terre/ocean
+
+  include 'indicesol.h'
+
+! Parametres d'entree
+  integer, intent(IN) :: itime
+  integer, intent(IN) :: iim, jjm
+  integer, intent(IN) :: klon
+  real, intent(IN) :: dtime
+  integer, intent(IN) :: jour
+  integer, intent(IN) :: nisurf
+  integer, intent(IN) :: knon
+  integer, dimension(knon), intent(in) :: knindex
+  real, dimension(klon,nbsrf), intent(IN) :: pctsrf
+  logical, intent(IN) :: debut, lafin, ok_veget
+  real, dimension(klon), intent(IN) :: rlon, rlat
+  real, dimension(knon), intent(IN) :: zlev
+  real, dimension(knon), intent(IN) :: u1_lay, v1_lay
+  real, dimension(knon), intent(IN) :: temp_air, spechum
+  real, dimension(knon), intent(IN) :: hum_air, ccanopy
+  real, dimension(knon), intent(IN) :: tq_cdrag, petAcoef, peqAcoef
+  real, dimension(knon), intent(IN) :: petBcoef, peqBcoef
+  real, dimension(knon), intent(IN) :: precip_rain, precip_snow
+  real, dimension(knon), intent(IN) :: lwdown, swnet, swdown, ps, albedo
+  real, dimension(knon), intent(IN) :: tsurf, p1lay, coef1lay
+  real, dimension(knon), intent(IN) :: radsol
+  real, dimension(klon), intent(IN) :: zmasq
+  character (len = 6)  :: ocean
+  real, dimension(knon), intent(INOUT) :: evap, snow, qsol
+
+! Parametres de sortie
+  real, dimension(knon), intent(OUT):: fluxsens, fluxlat
+  real, dimension(knon), intent(OUT):: tsol_rad, tsurf_new, alb_new
+  real, dimension(knon), intent(OUT):: emis_new, z0_new
+  real, dimension(knon), intent(OUT):: dflux_l, dflux_s
+  real, dimension(klon,nbsrf), intent(OUT) :: pctsrf_new
+
+! Local
+  character (len = 20) :: modname = 'interfsurf_hq'
+  character (len = 80) :: abort_message 
+  logical, save        :: first_call = .true.
+  integer              :: error
+  logical              :: check = .true.
+  real, dimension(knon):: cal, beta, dif_grnd, capsol
+  real, parameter      :: calice=1.0/(5.1444e+06*0.15), tau_gl=1./86400.*5.
+  real, parameter      :: calsno=1./(2.3867e+06*.15)
+
+#include "YOMCST.inc"
+
+  if (check) write(*,*) 'Entree ', modname
+!
+! On doit commencer par appeler les schemas de surfaces continentales
+! car l'ocean a besoin du ruissellement qui est y calcule
+!
+  if (first_call) then
+    if (nisurf /= is_ter .and. klon > 1) then 
+      write(*,*)' *** Warning ***'
+      write(*,*)' nisurf = ',nisurf,' /= is_ter = ',is_ter
+      write(*,*)'or on doit commencer par les surfaces continentales'
+      abort_message='voir ci-dessus'
+      call abort_gcm(modname,abort_message,1)
+    endif
+    if (ocean /= 'slab  ' .and. ocean /= 'force ' .and. ocean /= 'couple') then
+      write(*,*)' *** Warning ***'
+      write(*,*)'Option couplage pour l''ocean = ', ocean
+      abort_message='option pour l''ocean non valable'
+      call abort_gcm(modname,abort_message,1)
+    endif
+  endif
+  first_call = .false.
+!
+! Calcul age de la neige
+!
+  
+! Aiguillage vers les differents schemas de surface
+
+  if (nisurf == is_ter) then
+!
+! Surface "terre" appel a l'interface avec les sols continentaux
+!
+! allocation du run-off
+    if (.not. allocated(run_off)) then
+      allocate(run_off(knon), stat = error)
+      if (error /= 0) then
+        abort_message='Pb allocation run_off'
+        call abort_gcm(modname,abort_message,1)
+      endif
+    else if (size(run_off) /= knon) then
+      write(*,*)'Bizarre, le nombre de points continentaux'
+      write(*,*)'a change entre deux appels. Je continue ...'
+      deallocate(run_off, stat = error)
+      allocate(run_off(knon), stat = error)
+      if (error /= 0) then
+        abort_message='Pb allocation run_off'
+        call abort_gcm(modname,abort_message,1)
+      endif
+    endif
+!
+    if (.not. ok_veget) then
+!
+! calcul snow et qsol, hydrol adapté
+!
+      call calbeta(dtime, nisurf, knon, snow, qsol, beta, capsol, dif_grnd)
+      cal = RCPD * capsol
+      call calcul_fluxs( knon, nisurf, dtime, &
+     &   tsurf, p1lay, cal, beta, coef1lay, ps, &
+     &   precip_rain, precip_snow, snow, qsol,  &
+     &   radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, &
+     &   petAcoef, peqAcoef, petBcoef, peqBcoef, &
+     &   tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l)
+
+!
+! calcul albedo: lecture albedo fichier CL puis ajout albedo neige 
+! 
+    else
+!
+!  appel a sechiba
+!
+      call interfsol(itime, klon, dtime, nisurf, knon, &
+     &  knindex, rlon, rlat, &
+     &  debut, lafin, ok_veget, &
+     &  zlev,  u1_lay, v1_lay, temp_air, spechum, hum_air, ccanopy, & 
+     &  tq_cdrag, petAcoef, peqAcoef, petBcoef, peqBcoef, &
+     &  precip_rain, precip_snow, lwdown, swnet, swdown, &
+     &  tsurf, p1lay, coef1lay, ps, radsol, &
+     &  evap, fluxsens, fluxlat, &              
+     &  tsol_rad, tsurf_new, alb_new, emis_new, z0_new, dflux_l, dflux_s)
+    endif    
+!
+  else if (nisurf == is_oce) then
+
+    if (check) write(*,*)'ocean, nisurf = ',nisurf 
+
+
+!
+! Surface "ocean" appel a l'interface avec l'ocean
+!
+!    if (ocean == 'couple') then
+!      call interfoce(nisurf, ocean)
+!    else if (ocean == 'slab  ') then
+!      call interfoce(nisurf)
+!    else                              ! lecture conditions limites
+!      call interfoce(itime, dtime, jour, & 
+!     &  klon, nisurf, knon, knindex, &
+!     &  debut, &
+!     &  tsurf_new, alb_new, z0_new, pctsrf_new)
+!    endif
+!
+    cal = 0.
+    beta = 1.
+    dif_grnd = 0.
+
+    call calcul_fluxs( knon, nisurf, dtime, &
+     &   tsurf, p1lay, cal, beta, coef1lay, ps, &
+     &   precip_rain, precip_snow, snow, qsol,  &
+     &   radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, &
+     &   petAcoef, peqAcoef, petBcoef, peqBcoef, &
+     &   tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l)
+
+
+!
+! calcul albedo
+!
+
+!
+  else if (nisurf == is_sic) then
+
+    if (check) write(*,*)'sea ice, nisurf = ',nisurf 
+
+!
+! Surface "glace de mer" appel a l'interface avec l'ocean
+!
+!    call interfoce(nisurf, ocean)
+!
+
+    cal = calice
+    where (snow > 0.0) cal = calsno
+    beta = 1.0
+    dif_grnd = 1.0 / tau_gl
+
+    call calcul_fluxs( knon, nisurf, dtime, &
+     &   tsurf, p1lay, cal, beta, coef1lay, ps, &
+     &   precip_rain, precip_snow, snow, qsol,  &
+     &   radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, &
+     &   petAcoef, peqAcoef, petBcoef, peqBcoef, &
+     &   tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l)
+
+
+  else if (nisurf == is_lic) then
+
+    if (check) write(*,*)'glacier, nisurf = ',nisurf 
+
+!
+! Surface "glacier continentaux" appel a l'interface avec le sol
+!
+!    call interfsol(nisurf)
+
+    cal = calice
+    where (snow > 0.0) cal = calsno
+    beta = 1.0
+    dif_grnd = 0.0
+
+    call calcul_fluxs( knon, nisurf, dtime, &
+     &   tsurf, p1lay, cal, beta, coef1lay, ps, &
+     &   precip_rain, precip_snow, snow, qsol,  &
+     &   radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, &
+     &   petAcoef, peqAcoef, petBcoef, peqBcoef, &
+     &   tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l)
+
+  else
+    write(*,*)'Index surface = ',nisurf
+    abort_message = 'Index surface non valable'
+    call abort_gcm(modname,abort_message,1)
+  endif
+
+  END SUBROUTINE interfsurf_hq
+
+!
+!#########################################################################
+!
+  SUBROUTINE interfsurf_vent(nisurf, knon   &         
+  &                     )
+!
+! Cette routine sert d'aiguillage entre l'atmosphere et la surface en general 
+! (sols continentaux, oceans, glaces) pour les tensions de vents.
+! En pratique l'interface se fait entre la couche limite du modele 
+! atmospherique (clmain.F) et les routines de surface (sechiba, oasis, ...)
+!
+! 
+! L.Fairhead 02/2000
+!
+! input:
+!   nisurf       index de la surface a traiter (1 = sol continental)
+!   knon         nombre de points de la surface a traiter
+
+! Parametres d'entree
+  integer, intent(IN) :: nisurf
+  integer, intent(IN) :: knon
+
+
+  return
+  END SUBROUTINE interfsurf_vent
+!
+!#########################################################################
+!
+  SUBROUTINE interfsol(itime, klon, dtime, nisurf, knon, &
+     & knindex, rlon, rlat, &
+     & debut, lafin, ok_veget, &
+     & zlev,  u1_lay, v1_lay, temp_air, spechum, hum_air, ccanopy, & 
+     & tq_cdrag, petAcoef, peqAcoef, petBcoef, peqBcoef, &
+     & precip_rain, precip_snow, lwdown, swnet, swdown, &
+     & tsurf, p1lay, coef1lay, ps, radsol, &
+     & evap, fluxsens, fluxlat, &              
+     & tsol_rad, tsurf_new, alb_new, emis_new, z0_new, dflux_l, dflux_s)
+
+! Cette routine sert d'interface entre le modele atmospherique et le 
+! modele de sol continental. Appel a sechiba
+!
+! L. Fairhead 02/2000
+!
+! input:
+!   itime        numero du pas de temps
+!   klon         nombre total de points de grille
+!   dtime        pas de temps de la physique (en s)
+!   nisurf       index de la surface a traiter (1 = sol continental)
+!   knon         nombre de points de la surface a traiter
+!   knindex      index des points de la surface a traiter
+!   rlon         longitudes de la grille entiere
+!   rlat         latitudes de la grille entiere
+!   debut        logical: 1er appel a la physique (lire les restart)
+!   lafin        logical: dernier appel a la physique (ecrire les restart)
+!   ok_veget     logical: appel ou non au schema de surface continental
+!                     (si false calcul simplifie des fluxs sur les continents)
+!   zlev         hauteur de la premiere couche       
 !   u1_lay       vitesse u 1ere couche
 !   v1_lay       vitesse v 1ere couche
@@ -98,11 +408,11 @@
 !   tsurf        temperature de surface
 !   p1lay        pression 1er niveau (milieu de couche)
-!   cal          capacite calorifique du sol
-!   beta         evap reelle
 !   coef1lay     coefficient d'echange
 !   ps           pression au sol
 !   radsol       rayonnement net aus sol (LW + SW)
-!   dif_grnd     coeff. diffusion vers le sol profond
-!   ocean        type d'ocean utilise (force, slab, couple)
+!   
+!
+! input/output
+!   run_off      ruissellement total
 !
 ! output:
@@ -116,255 +426,4 @@
 !   z0_new       surface roughness
 
-  include 'indicesol.h'
-
-! Parametres d'entree
-  integer, intent(IN) :: itime
-  integer, intent(IN) :: klon
-  real, intent(IN) :: dtime
-  integer, intent(IN) :: jour
-  integer, intent(IN) :: nisurf
-  integer, intent(IN) :: knon
-  integer, dimension(knon), intent(in) :: knindex
-  logical, intent(IN) :: debut, lafin, ok_veget
-  real, dimension(klon), intent(IN) :: rlon, rlat
-  real, dimension(knon), intent(IN) :: zlev, zlflu
-  real, dimension(knon), intent(IN) :: u1_lay, v1_lay
-  real, dimension(knon), intent(IN) :: temp_air, spechum
-  real, dimension(knon), intent(IN) :: hum_air, ccanopy
-  real, dimension(knon), intent(IN) :: tq_cdrag, petAcoef, peqAcoef
-  real, dimension(knon), intent(IN) :: petBcoef, peqBcoef
-  real, dimension(knon), intent(IN) :: precip_rain, precip_snow
-  real, dimension(knon), intent(IN) :: lwdown, swnet, swdown, ps
-  real, dimension(knon), intent(IN) :: tsurf, p1lay, cal, beta, coef1lay
-  real, dimension(knon), intent(IN) :: radsol, dif_grnd
-  character (len = 6)  :: ocean
-
-! Parametres de sortie
-  real, dimension(knon), intent(OUT):: evap, fluxsens, fluxlat
-  real, dimension(knon), intent(OUT):: tsol_rad, tsurf_new, alb_new
-  real, dimension(knon), intent(OUT):: emis_new, z0_new
-  real, dimension(knon), intent(OUT):: dflux_l, dflux_s
-  real, dimension(klon,nbsrf), intent(OUT) :: pctsrf_new
-
-! Local
-  character (len = 20) :: modname = 'interfsurf_hq'
-  character (len = 80) :: abort_message 
-  logical, save        :: first_call = .true.
-  integer              :: error
-  logical              :: check = .true.
-
-  if (check) write(*,*) 'Entree ', modname
-!
-! On doit commencer par appeler les schemas de surfaces continentales
-! car l'ocean a besoin du ruissellement qui est y calcule
-!
-  if (first_call) then
-    if (nisurf /= is_ter .and. klon > 1) then 
-      write(*,*)' *** Warning ***'
-      write(*,*)' nisurf = ',nisurf,' /= is_ter = ',is_ter
-      write(*,*)'or on doit commencer par les surfaces continentales'
-      abort_message='voir ci-dessus'
-      call abort_gcm(modname,abort_message,1)
-    endif
-    if (ocean /= 'slab  ' .and. ocean /= 'force ' .and. ocean /= 'couple') then
-      write(*,*)' *** Warning ***'
-      write(*,*)'Option couplage pour l''ocean = ', ocean
-      abort_message='option pour l''ocean non valable'
-      call abort_gcm(modname,abort_message,1)
-    endif
-  endif
-  first_call = .false.
-
-! Aiguillage vers les differents schemas de surface
-
-  if (nisurf == is_ter) then
-!
-! Surface "terre" appel a l'interface avec les sols continentaux
-!
-! allocation du run-off
-    if (.not. allocated(run_off)) then
-      allocate(run_off(knon), stat = error)
-      if (error /= 0) then
-        abort_message='Pb allocation run_off'
-        call abort_gcm(modname,abort_message,1)
-      endif
-    else if (size(run_off) /= knon) then
-      write(*,*)'Bizarre, le nombre de points continentaux'
-      write(*,*)'a change entre deux appels. Je continue ...'
-      deallocate(run_off, stat = error)
-      allocate(run_off(knon), stat = error)
-      if (error /= 0) then
-        abort_message='Pb allocation run_off'
-        call abort_gcm(modname,abort_message,1)
-      endif
-    endif
-!
-    call interfsol(itime, klon, dtime, nisurf, knon, &
-     &  knindex, rlon, rlat, &
-     &  debut, lafin, ok_veget, &
-     &  zlev, zlflu, u1_lay, v1_lay, temp_air, spechum, hum_air, ccanopy, & 
-     &  tq_cdrag, petAcoef, peqAcoef, petBcoef, peqBcoef, &
-     &  precip_rain, precip_snow, lwdown, swnet, swdown, &
-     &  tsurf, p1lay, cal, beta, coef1lay, ps, radsol, dif_grnd, &
-     &  evap, fluxsens, fluxlat, &              
-     &  tsol_rad, tsurf_new, alb_new, emis_new, z0_new, dflux_l, dflux_s)
-      
-!
-  else if (nisurf == is_oce) then
-
-    if (check) write(*,*)'ocean, nisurf = ',nisurf 
-!
-! Surface "ocean" appel a l'interface avec l'ocean
-!
-!    if (ocean == 'couple') then
-!      call interfoce(nisurf, ocean)
-!    else if (ocean == 'slab  ') then
-!      call interfoce(nisurf)
-!    else                              ! lecture conditions limites
-!      call interfoce(itime, dtime, jour, & 
-!     &  klon, nisurf, knon, knindex, &
-!     &  debut, &
-!     &  tsurf_new, alb_new, z0_new, pctsrf_new)
-!    endif
-!
-    call calcul_fluxs( knon, dtime, &
-     &   tsurf, p1lay, cal, beta, coef1lay, ps, &
-     &   radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, &
-     &   petAcoef, peqAcoef, petBcoef, peqBcoef, &
-     &   tsurf_new, fluxlat, fluxsens, dflux_s, dflux_l)
-!
-  else if (nisurf == is_sic) then
-
-    if (check) write(*,*)'sea ice, nisurf = ',nisurf 
-
-!
-! Surface "glace de mer" appel a l'interface avec l'ocean
-!
-!    call interfoce(nisurf, ocean)
-!
-    call calcul_fluxs( knon, dtime, &
-     &   tsurf, p1lay, cal, beta, coef1lay, ps, &
-     &   radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, &
-     &   petAcoef, peqAcoef, petBcoef, peqBcoef, &
-     &   tsurf_new, fluxlat, fluxsens, dflux_s, dflux_l)
-
-  else if (nisurf == is_lic) then
-
-    if (check) write(*,*)'glacier, nisurf = ',nisurf 
-
-!
-! Surface "glacier continentaux" appel a l'interface avec le sol
-!
-!    call interfsol(nisurf)
-    call calcul_fluxs( knon, dtime, &
-     &   tsurf, p1lay, cal, beta, coef1lay, ps, &
-     &   radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, &
-     &   petAcoef, peqAcoef, petBcoef, peqBcoef, &
-     &   tsurf_new, fluxlat, fluxsens, dflux_s, dflux_l)
-
-  else
-    write(*,*)'Index surface = ',nisurf
-    abort_message = 'Index surface non valable'
-    call abort_gcm(modname,abort_message,1)
-  endif
-
-  END SUBROUTINE interfsurf_hq
-
-!
-!#########################################################################
-!
-  SUBROUTINE interfsurf_vent(nisurf, knon   &         
-  &                     )
-!
-! Cette routine sert d'aiguillage entre l'atmosphere et la surface en general 
-! (sols continentaux, oceans, glaces) pour les tensions de vents.
-! En pratique l'interface se fait entre la couche limite du modele 
-! atmospherique (clmain.F) et les routines de surface (sechiba, oasis, ...)
-!
-! 
-! L.Fairhead 02/2000
-!
-! input:
-!   nisurf       index de la surface a traiter (1 = sol continental)
-!   knon         nombre de points de la surface a traiter
-
-! Parametres d'entree
-  integer, intent(IN) :: nisurf
-  integer, intent(IN) :: knon
-
-
-  return
-  END SUBROUTINE interfsurf_vent
-!
-!#########################################################################
-!
-  SUBROUTINE interfsol(itime, klon, dtime, nisurf, knon, &
-     & knindex, rlon, rlat, &
-     & debut, lafin, ok_veget, &
-     & zlev, zlflu, u1_lay, v1_lay, temp_air, spechum, hum_air, ccanopy, & 
-     & tq_cdrag, petAcoef, peqAcoef, petBcoef, peqBcoef, &
-     & precip_rain, precip_snow, lwdown, swnet, swdown, &
-     & tsurf, p1lay, cal, beta, coef1lay, ps, radsol, dif_grnd, &
-     & evap, fluxsens, fluxlat, &              
-     & tsol_rad, tsurf_new, alb_new, emis_new, z0_new, dflux_l, dflux_s)
-
-! Cette routine sert d'interface entre le modele atmospherique et le 
-! modele de sol continental. Appel a sechiba
-!
-! L. Fairhead 02/2000
-!
-! input:
-!   itime        numero du pas de temps
-!   klon         nombre total de points de grille
-!   dtime        pas de temps de la physique (en s)
-!   nisurf       index de la surface a traiter (1 = sol continental)
-!   knon         nombre de points de la surface a traiter
-!   knindex      index des points de la surface a traiter
-!   rlon         longitudes de la grille entiere
-!   rlat         latitudes de la grille entiere
-!   debut        logical: 1er appel a la physique (lire les restart)
-!   lafin        logical: dernier appel a la physique (ecrire les restart)
-!   ok_veget     logical: appel ou non au schema de surface continental
-!                     (si false calcul simplifie des fluxs sur les continents)
-!   zlev         hauteur de la premiere couche
-!   zlflu        
-!   u1_lay       vitesse u 1ere couche
-!   v1_lay       vitesse v 1ere couche
-!   temp_air     temperature de l'air 1ere couche
-!   spechum      humidite specifique 1ere couche
-!   hum_air      humidite de l'air
-!   ccanopy      concentration CO2 canopee
-!   tq_cdrag     cdrag
-!   petAcoef     coeff. A de la resolution de la CL pour t
-!   peqAcoef     coeff. A de la resolution de la CL pour q
-!   petBcoef     coeff. B de la resolution de la CL pour t
-!   peqBcoef     coeff. B de la resolution de la CL pour q
-!   precip_rain  precipitation liquide
-!   precip_snow  precipitation solide
-!   lwdown       flux IR entrant a la surface
-!   swnet        flux solaire net
-!   swdown       flux solaire entrant a la surface
-!   tsurf        temperature de surface
-!   p1lay        pression 1er niveau (milieu de couche)
-!   cal          capacite calorifique du sol
-!   beta         evap reelle
-!   coef1lay     coefficient d'echange
-!   ps           pression au sol
-!   radsol       rayonnement net aus sol (LW + SW)
-!   dif_grnd     coeff. diffusion vers le sol profond      
-!   
-!
-! input/output
-!   run_off      ruissellement total
-!
-! output:
-!   evap         evaporation totale
-!   fluxsens     flux de chaleur sensible
-!   fluxlat      flux de chaleur latente
-!   tsol_rad     
-!   tsurf_new    temperature au sol
-!   alb_new      albedo
-!   emis_new     emissivite
-!   z0_new       surface roughness
 
 ! Parametres d'entree
@@ -377,5 +436,5 @@
   logical, intent(IN) :: debut, lafin, ok_veget
   real, dimension(klon), intent(IN) :: rlon, rlat
-  real, dimension(knon), intent(IN) :: zlev, zlflu
+  real, dimension(knon), intent(IN) :: zlev
   real, dimension(knon), intent(IN) :: u1_lay, v1_lay
   real, dimension(knon), intent(IN) :: temp_air, spechum
@@ -385,6 +444,6 @@
   real, dimension(knon), intent(IN) :: precip_rain, precip_snow
   real, dimension(knon), intent(IN) :: lwdown, swnet, swdown, ps
-  real, dimension(knon), intent(IN) :: tsurf, p1lay, cal, beta, coef1lay
-  real, dimension(knon), intent(IN) :: radsol, dif_grnd
+  real, dimension(knon), intent(IN) :: tsurf, p1lay, coef1lay
+  real, dimension(knon), intent(IN) :: radsol
 ! Parametres de sortie
   real, dimension(knon), intent(OUT):: evap, fluxsens, fluxlat
@@ -400,4 +459,5 @@
   character (len = 80) :: abort_message
   logical              :: check = .true.
+  real, dimension(knon) :: cal, beta, dif_grnd, capsol
 ! type de couplage dans sechiba
 !  character (len=10)   :: coupling = 'implicit' 
@@ -414,15 +474,10 @@
   integer, save          :: rest_id_stom, hist_id_stom
 
+  real, dimension(knon):: snow, qsol
+
   if (check) write(*,*)'Entree ', modname
   if (check) write(*,*)'ok_veget = ',ok_veget
 
 ! initialisation
-  if (.not. ok_veget) then
-    call calcul_fluxs( knon, dtime, &
-     &   tsurf, p1lay, cal, beta, coef1lay, ps, &
-     &   radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, &
-     &   petAcoef, peqAcoef, petBcoef, peqBcoef, &
-     &   tsurf_new, fluxlat, fluxsens, dflux_s, dflux_l)
-  else
 !    if (debut) then
 !      !
@@ -476,5 +531,5 @@
 !     & debut, lafin, coupling, control_in, &
 !     & lalo, neighbours, resolution,&
-!     & zlev, zlflu, u1_lay, v1_lay, spechum, temp_air,hum_air , ccanopy, &
+!     & zlev,  u1_lay, v1_lay, spechum, temp_air,hum_air , ccanopy, &
 !     & tq_cdrag, petAcoef, peqAcoef, petBcoef, peqBcoef, &
 !     & precip_rain, precip_snow, lwdown, swnet, swdown, ps, &
@@ -486,5 +541,4 @@
 ! Sauvegarde dans fichiers histoire
 !
-  endif  ! fin ok_veget
 
   END SUBROUTINE interfsol
@@ -492,5 +546,12 @@
 !#########################################################################
 !
-  SUBROUTINE interfoce_cpl(nisurf, ocean)
+  SUBROUTINE interfoce_cpl(itime, dtime, &
+      & klon, iim, jjm, nisurf, pctsrf, knon, knindex, rlon, rlat, &
+      & ocean, nexca, debut, lafin, &
+      & swdown, lwdown, precip_rain, precip_snow, evap, tsurf, &
+      & fder, albsol, taux, tauy, &
+      & tsurf_new, alb_new, alb_ice, pctsrf_new)
+
+
 
 ! Cette routine sert d'interface entre le modele atmospherique et un 
